//+------------------------------------------------------------------+
//|                                                     VSI_twin.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//|                       "Copyright  2005, DriverDan"              |
//|                             superfunman2000@yahoo.com            |
//+------------------------------------------------------------------+
/*
 * Filename:    VSI.mq4
 * Author:      DriverDan
 * Date:        Oct 20, 2005
 *
 * Description: Indicator that calculates volume per second (or period) and the corresponding MA.
 *              Uses volume per second since it will be uniform for all chart periods.
 *              Indicator seems to work best on 15m to 4h charts. IMHO, 1m and 5m periods are
 *              too short for valid results and 1d+ will show low periods for partial days on MT4.
 *
 * Version:     1.0
 *              Initial release
 */

#property copyright         "Copyright  2005, DriverDan"
#property link              "superfunman2000@yahoo.com"
//----
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  FireBrick
#property indicator_color2  MediumBlue
#property indicator_level1 0.0
//----
extern int SPeriod   =4;
double vsiBufferUp[];
double vsiBufferDw[];
double vsiBufferUpS[];
double vsiBufferDwS[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  int init() 
  {
   IndicatorDigits(Digits);
   IndicatorBuffers(4);
   string vsiTitle="VSI_twin";
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(0, vsiBufferUpS);
   SetIndexBuffer(1, vsiBufferDwS);
   SetIndexBuffer(2, vsiBufferUp);
   SetIndexBuffer(3, vsiBufferDw);
   IndicatorShortName(vsiTitle);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  int start() 
  {
   int i, limit, timeDiff;
   int counted_bars=IndicatorCounted();
      //If counted bars is greater than zero we must subtract 1 so we get in the right position
        if(counted_bars > 0) 
        {
         counted_bars--;
        }
      //Only count bars we haven't already drawn
      limit=Bars - counted_bars;
//----
     for(i=0; i < limit; i++) 
   {
         //Difference between the current time and the bar start
         timeDiff=TimeCurrent() - Time[i];
    if(i==0 && timeDiff > 0)
     { 
      if(Close[i]-Open[i]>=0.0)       
      vsiBufferUp[i] = ((Volume[i]-(Close[i]-Open[i])/Point)/2.0+(Close[i]-Open[i])/Point)/timeDiff;
      if(Close[i]-Open[i]<0.0)       
      vsiBufferDw[i] = ((Volume[i]+(Close[i]-Open[i])/Point)/2.0-(Close[i]-Open[i])/Point)/timeDiff*(-1.0);
     }
    else
     {
      if(Close[i]-Open[i]>=0.0)       
      vsiBufferUp[i] = ((Volume[i]-(Close[i]-Open[i])/Point)/2.0+(Close[i]-Open[i])/Point)/(Time[i - 1] - Time[i]);
      if(Close[i]-Open[i]<0.0)       
      vsiBufferDw[i] = ((Volume[i]+(Close[i]-Open[i])/Point)/2.0-(Close[i]-Open[i])/Point)/(Time[i - 1] - Time[i])*(-1.0);
    }
  }
    for(i=0; i < limit; i++) 
     {
      vsiBufferUpS[i]=iMAOnArray(vsiBufferUp, Bars, SPeriod, 0, MODE_EMA, i);
      vsiBufferDwS[i]=iMAOnArray(vsiBufferDw, Bars, SPeriod, 0, MODE_EMA, i);
     }
   return(0);
  }
//+------------------------------------------------------------------+